/**************************************************************************/
/*                                                                        */
/* Copyright (c) 2001, 2004 NoMachine, http://www.nomachine.com.          */
/*                                                                        */
/* NXAGENT, NX protocol compression and NX extensions to this software    */
/* are copyright of NoMachine. Redistribution and use of the present      */
/* software is allowed according to terms specified in the file LICENSE   */
/* which comes in the source distribution.                                */
/*                                                                        */
/* Check http://www.nomachine.com/licensing.html for applicability.       */
/*                                                                        */
/* NX and NoMachine are trademarks of Medialogic S.p.A.                   */
/*                                                                        */
/* All rights reserved.                                                   */
/*                                                                        */
/**************************************************************************/

#include "X.h"
#include "keysym.h"

#include "screenint.h"
#include "scrnintstr.h"

#include "Agent.h"
#include "Display.h"
#include "Events.h"
#include "Options.h"

extern Bool windowManagerRunning;
extern Bool nxagentIpaq;

/*
 * Set here the required log level.
 */
                                                                                                 
#define PANIC
#define WARNING
#undef  TEST
#undef  DEBUG

int nxagentCheckSpecialKeystroke(XKeyEvent *X, enum HandleEventResult *result)
{
  KeySym sym;
  int    index = 0;

  /*
   * I don't know how much hard work is doing this operation.
   * Do we need a cache ?
   */

  sym = XKeycodeToKeysym(nxagentDisplay, X -> keycode, index);

  if (sym == XK_VoidSymbol || sym == NoSymbol)
  {
    return 0;
  }

  #ifdef TEST
  fprintf(stderr, "nxagentCheckSpecialKeystroke: got code %x - state %x - sym %x\n",
            X -> keycode, X -> state, sym);
  #endif
 
  /*
   * We cannot catch the Alt modifier on a
   * X server running on a MacOS. So we added
   * the same keystrokes combination except for
   * for the Alt key substituted with the Apple
   * modifier.
   */

  if (X -> state & (Mod1Mask | Mod2Mask))
  {
    if ((sym == XK_F4  && (X -> state & (ControlMask | ShiftMask)) == (0)) ||
       (sym == XK_Tab && (X -> state & (ControlMask | ShiftMask)) == (ControlMask | ShiftMask)))
    {
      *result = do_closeSession;

      return 1;
    }
  }

  /*
   * FIXME: We should use the keysym instead that the keycode
   *        here.
   */
  
  if (X -> keycode == 130 && nxagentIpaq)
  {
    *result = do_startKbd;

    return 1;
  }

  if (nxagentOption(Fullscreen) && windowManagerRunning)
  {
    if ((sym == XK_Escape && ((X -> state & (ControlMask | Mod1Mask | ShiftMask)) == 
          (ControlMask|Mod1Mask))) ||
        (sym == XK_F2 && ((X -> state & (ControlMask | Mod1Mask | ShiftMask)) ==
          (Mod1Mask))))
    {
      *result = do_minimize;

      return 1;
    }
  }

  return 0;
}
